import { jsx as _jsx } from "react/jsx-runtime";
import { InputAdornment } from "@mui/material";
import { forwardRef } from "react";
import NerdMaskField from "../nerdMaskField/nerdMaskField";
/**
 *
 * @param {NerdCurrencyFieldProps} props Component props
 * @returns {ReactElement} NerdCurrencyField
 */
export default forwardRef(function NerdCurrencyField(props, parentRef) {
    const { value, onChange, inputProps, currencySymbol = "$", decimalCharacter = ".", digitGroupSeparator = ",", multiplier, signed, normalizeZeros = false, padFractionalZeros = false, max, min, maxDigitAfterDecimal, } = props;
    return (_jsx(NerdMaskField, { inputRef: (ref) => {
            if (typeof parentRef === "function")
                parentRef(ref);
            else if (parentRef !== null)
                parentRef.current = ref;
        }, value: value != undefined
            ? multiplier
                ? value != "-"
                    ? (value / multiplier).toString()
                    : value
                : value.toString()
            : "", inputProps: {
            startDecorator: (_jsx(InputAdornment, { position: "start", children: currencySymbol })),
            sx: { textAlign: "right" },
            ...inputProps,
        }, mask: "m", blocks: {
            m: {
                mask: Number,
                signed,
                thousandsSeparator: digitGroupSeparator,
                scale: multiplier && multiplier > 9
                    ? multiplier.toFixed().length - 1
                    : maxDigitAfterDecimal != undefined
                        ? maxDigitAfterDecimal
                        : 16,
                normalizeZeros,
                radix: decimalCharacter,
                padFractionalZeros,
                max,
                min,
            },
        }, onAccept: (inputValue, mask) => {
            if (inputValue !== "-" &&
                !inputValue.match(new RegExp(`^-0*\\${decimalCharacter}?0*$`))) {
                const newValue = Number(mask.unmaskedValue);
                if (mask.value === "")
                    onChange?.(undefined);
                else if (newValue != value) {
                    onChange?.(multiplier ? newValue * multiplier : newValue);
                }
            }
        } }));
});
