import { createSelector, createSlice } from "@reduxjs/toolkit";
const nerdHistoryInitialState = {
    open: false,
    openKey: "",
};
export const nerdHistory = createSlice({
    name: "nerdHistory",
    initialState: nerdHistoryInitialState,
    reducers: {
        setNerdHistoryOpen: (state, action) => {
            if (state.openKey)
                localStorage.setItem(state.openKey, action.payload.toString());
            state.open = action.payload;
            return state;
        },
        setNerdHistoryOpenKey: (state, action) => {
            state.openKey = action.payload;
            return state;
        },
    },
});
export const { setNerdHistoryOpen, setNerdHistoryOpenKey } = nerdHistory.actions;
export const nerdHistoryReducer = nerdHistory.reducer;
const selectNerdHistoryOpen = (state) => state.nerdUIState.nerdHistory.open;
export const nerdHistoryOpenSelector = createSelector([selectNerdHistoryOpen], (s) => {
    return s;
});
